package core.service;

import db.AbstractModel;
import db.DBAction;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.hibernate.criterion.DetachedCriteria;
import org.hibernate.criterion.Projections;
import org.springframework.dao.DataAccessException;
import org.springframework.orm.hibernate5.HibernateTemplate;

import java.util.List;

/**
 * Created by reborn on 2017/7/28.
 */
public abstract class BaseService {

    protected static Logger log=LogManager.getLogger();

    protected abstract HibernateTemplate getHibernateTemplate() ;

    public<T extends AbstractModel> T curd(DBAction action, T command) throws DataAccessException {
        switch (action) {
            case C:
                getHibernateTemplate().save(command);break;
            case U:
                getHibernateTemplate().update(command);break;
            case R:
                AbstractModel model=getHibernateTemplate().get(command.getClass(), command.primaryKey());
                if(model!=null){
                    return model.cast();
                }
            case D:
                getHibernateTemplate().delete(command);break;
            default:
                throw new RuntimeException("非法操作：" + action);
        }
        return null;

    }

    public <T extends  AbstractModel> List find(T command, int firstResult, int maxResults){
        return getHibernateTemplate().findByCriteria(command.getCriteria(),firstResult,maxResults);
    }

    public <T extends  AbstractModel> Long rowCount(Class<T> tClass){
        return getHibernateTemplate().executeWithNativeSession(session -> (Long) DetachedCriteria.forClass(tClass).setProjection(Projections.rowCount()).getExecutableCriteria(session).uniqueResult());
    }

}
