package db;

import com.fasterxml.jackson.annotation.JsonIgnore;
import org.hibernate.criterion.DetachedCriteria;

import java.io.Serializable;

/**
 * Created by reborn on 2017/8/3.
 */

public abstract class AbstractModel extends ToJSON{

    public abstract Serializable primaryKey();

    public abstract String tableNote();

    @JsonIgnore
    public DetachedCriteria getCriteria() {
        return DetachedCriteria.forClass(this.getClass());
    }
    @SuppressWarnings("unchecked")
    public <T extends AbstractModel> T cast() throws ClassCastException{
        return (T) this;
    }
}
