package db;

import java.util.List;

public class PageResult<T extends AbstractModel> {
    private long count;

    private int currentPage;

    private List<T> datas;

    private int pageSize;

    private long pages;

    private Type type;

    private String errorMsg;

    /**
     *
     * @param count 总行数
     * @param currentPage 当前分页数
     * @param datas 数据
     * @param pageSize 分页大小
     * @param type 操作结果
     */
    public PageResult(long count, int currentPage, List<T> datas, int pageSize, Type type) {
        this.count = count;
        this.currentPage = currentPage+1;
        this.datas = datas;
        this.pageSize = pageSize;
        this.pages=count%pageSize==0?count/pageSize:count/pageSize+1;
        this.type = type;
    }

    public PageResult(Type type, String errorMsg) {
        this.type = type;
        this.errorMsg = errorMsg;
    }

    public long getCount() {
        return count;
    }

    public int getCurrentPage() {
        return currentPage;
    }

    public List<T> getDatas() {
        return datas;
    }

    public Type getType() {
        return type;
    }

    public int getPageSize() {
        return pageSize;
    }

    public long getPages() {
        return pages;
    }

    public String getErrorMsg() {
        return errorMsg;
    }
}
