package db.model;

import db.AbstractModel;

import javax.persistence.*;
import java.io.Serializable;
import java.util.Objects;

@Entity
@Table(name = "datasource", schema = "rootdb", catalog = "")
public class DataSourceModel extends AbstractModel {
    private String dbDesc;
    private String hostname;
    private int dbPort;
    private String username;
    private String dbPassword;
    private String dbName;
    private String annotation;

    @Id
    @Column(name = "db_desc", nullable = false, length = 10)
    public String getDbDesc() {
        return dbDesc;
    }

    public void setDbDesc(String dbDesc) {
        this.dbDesc = dbDesc;
    }

    @Basic
    @Column(name = "hostname", nullable = false, length = 32)
    public String getHostname() {
        return hostname;
    }

    public void setHostname(String hostname) {
        this.hostname = hostname;
    }

    @Basic
    @Column(name = "db_port", nullable = false)
    public int getDbPort() {
        return dbPort;
    }

    public void setDbPort(int dbPort) {
        this.dbPort = dbPort;
    }

    @Basic
    @Column(name = "username", nullable = false, length = 10)
    public String getUsername() {
        return username;
    }

    public void setUsername(String username) {
        this.username = username;
    }

    @Basic
    @Column(name = "db_password", nullable = false, length = 10)
    public String getDbPassword() {
        return dbPassword;
    }

    public void setDbPassword(String dbPassword) {
        this.dbPassword = dbPassword;
    }

    @Basic
    @Column(name = "db_name", nullable = false, length = 10)
    public String getDbName() {
        return dbName;
    }

    public void setDbName(String dbName) {
        this.dbName = dbName;
    }

    @Basic
    @Column(name = "annotation", nullable = true, length = 10)
    public String getAnnotation() {
        return annotation;
    }

    public void setAnnotation(String annotation) {
        this.annotation = annotation;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        DataSourceModel that = (DataSourceModel) o;
        return dbPort == that.dbPort &&
                Objects.equals(dbDesc, that.dbDesc) &&
                Objects.equals(hostname, that.hostname) &&
                Objects.equals(username, that.username) &&
                Objects.equals(dbPassword, that.dbPassword) &&
                Objects.equals(dbName, that.dbName) &&
                Objects.equals(annotation, that.annotation);
    }

    @Override
    public int hashCode() {

        return Objects.hash(dbDesc, hostname, dbPort, username, dbPassword, dbName, annotation);
    }

    @Override
    public Serializable primaryKey() {
        return getDbDesc();
    }

    @Override
    public String tableNote() {
        return "数据源";
    }
}
