package db.model.bilibili;

import db.AbstractModel;

import javax.persistence.*;
import java.io.Serializable;
import java.util.Objects;

@Entity
@Table(name = "cid", schema = "bilibili", catalog = "bilibili")
public class CidEntity extends AbstractModel {
    private int cid;
    private Integer maxlimit;
    private Integer chatid;
    private String server;
    private String vtype;
    private String oriurl;
    private Integer aid;
    private Integer typeid;
    private Integer pid;
    private Integer click;
    private Integer favourites;
    private Integer credits;
    private Integer coins;
    private Integer fwClick;
    private String duration;
    private String arctype;
    private Integer danmu;
    private Integer bottom;
    private Integer sinapi;
    private String acceptguest;
    private String acceptaccel;

    @Id
    @Column(name = "cid")
    public int getCid() {
        return cid;
    }

    public void setCid(int cid) {
        this.cid = cid;
    }

    @Basic
    @Column(name = "maxlimit")
    public Integer getMaxlimit() {
        return maxlimit;
    }

    public void setMaxlimit(Integer maxlimit) {
        this.maxlimit = maxlimit;
    }

    @Basic
    @Column(name = "chatid")
    public Integer getChatid() {
        return chatid;
    }

    public void setChatid(Integer chatid) {
        this.chatid = chatid;
    }

    @Basic
    @Column(name = "server")
    public String getServer() {
        return server;
    }

    public void setServer(String server) {
        this.server = server;
    }

    @Basic
    @Column(name = "vtype")
    public String getVtype() {
        return vtype;
    }

    public void setVtype(String vtype) {
        this.vtype = vtype;
    }

    @Basic
    @Column(name = "oriurl")
    public String getOriurl() {
        return oriurl;
    }

    public void setOriurl(String oriurl) {
        this.oriurl = oriurl;
    }

    @Basic
    @Column(name = "aid")
    public Integer getAid() {
        return aid;
    }

    public void setAid(Integer aid) {
        this.aid = aid;
    }

    @Basic
    @Column(name = "typeid")
    public Integer getTypeid() {
        return typeid;
    }

    public void setTypeid(Integer typeid) {
        this.typeid = typeid;
    }

    @Basic
    @Column(name = "pid")
    public Integer getPid() {
        return pid;
    }

    public void setPid(Integer pid) {
        this.pid = pid;
    }

    @Basic
    @Column(name = "click")
    public Integer getClick() {
        return click;
    }

    public void setClick(Integer click) {
        this.click = click;
    }

    @Basic
    @Column(name = "favourites")
    public Integer getFavourites() {
        return favourites;
    }

    public void setFavourites(Integer favourites) {
        this.favourites = favourites;
    }

    @Basic
    @Column(name = "credits")
    public Integer getCredits() {
        return credits;
    }

    public void setCredits(Integer credits) {
        this.credits = credits;
    }

    @Basic
    @Column(name = "coins")
    public Integer getCoins() {
        return coins;
    }

    public void setCoins(Integer coins) {
        this.coins = coins;
    }

    @Basic
    @Column(name = "fw_click")
    public Integer getFwClick() {
        return fwClick;
    }

    public void setFwClick(Integer fwClick) {
        this.fwClick = fwClick;
    }

    @Basic
    @Column(name = "duration")
    public String getDuration() {
        return duration;
    }

    public void setDuration(String duration) {
        this.duration = duration;
    }

    @Basic
    @Column(name = "arctype")
    public String getArctype() {
        return arctype;
    }

    public void setArctype(String arctype) {
        this.arctype = arctype;
    }

    @Basic
    @Column(name = "danmu")
    public Integer getDanmu() {
        return danmu;
    }

    public void setDanmu(Integer danmu) {
        this.danmu = danmu;
    }

    @Basic
    @Column(name = "bottom")
    public Integer getBottom() {
        return bottom;
    }

    public void setBottom(Integer bottom) {
        this.bottom = bottom;
    }

    @Basic
    @Column(name = "sinapi")
    public Integer getSinapi() {
        return sinapi;
    }

    public void setSinapi(Integer sinapi) {
        this.sinapi = sinapi;
    }

    @Basic
    @Column(name = "acceptguest")
    public String getAcceptguest() {
        return acceptguest;
    }

    public void setAcceptguest(String acceptguest) {
        this.acceptguest = acceptguest;
    }

    @Basic
    @Column(name = "acceptaccel")
    public String getAcceptaccel() {
        return acceptaccel;
    }

    public void setAcceptaccel(String acceptaccel) {
        this.acceptaccel = acceptaccel;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        CidEntity cidEntity = (CidEntity) o;
        return cid == cidEntity.cid &&
                Objects.equals(maxlimit, cidEntity.maxlimit) &&
                Objects.equals(chatid, cidEntity.chatid) &&
                Objects.equals(server, cidEntity.server) &&
                Objects.equals(vtype, cidEntity.vtype) &&
                Objects.equals(oriurl, cidEntity.oriurl) &&
                Objects.equals(aid, cidEntity.aid) &&
                Objects.equals(typeid, cidEntity.typeid) &&
                Objects.equals(pid, cidEntity.pid) &&
                Objects.equals(click, cidEntity.click) &&
                Objects.equals(favourites, cidEntity.favourites) &&
                Objects.equals(credits, cidEntity.credits) &&
                Objects.equals(coins, cidEntity.coins) &&
                Objects.equals(fwClick, cidEntity.fwClick) &&
                Objects.equals(duration, cidEntity.duration) &&
                Objects.equals(arctype, cidEntity.arctype) &&
                Objects.equals(danmu, cidEntity.danmu) &&
                Objects.equals(bottom, cidEntity.bottom) &&
                Objects.equals(sinapi, cidEntity.sinapi) &&
                Objects.equals(acceptguest, cidEntity.acceptguest) &&
                Objects.equals(acceptaccel, cidEntity.acceptaccel);
    }

    @Override
    public int hashCode() {
        return Objects.hash(cid, maxlimit, chatid, server, vtype, oriurl, aid, typeid, pid, click, favourites, credits, coins, fwClick, duration, arctype, danmu, bottom, sinapi, acceptguest, acceptaccel);
    }

    @Override
    public Serializable primaryKey() {
        return getCid();
    }

    @Override
    public String tableNote() {
        return "CID表";
    }
}
