package db.model.bilibili;

import db.AbstractModel;
import db.annotation.BiliBili;

import javax.persistence.*;
import java.io.Serializable;
import java.util.Objects;

@BiliBili
@Entity
@Table(name = "data", schema = "bilibili", catalog = "bilibili")
public class DataModel extends AbstractModel {
    private int cid;
    private Integer aid;
    private String author;
    private String backupVid;
    private String cache;
    private String cover;
    private Integer dispatch;
    private Integer dispatchServers;
    private Byte dpDone;
    private Byte dpDoneFlv;
    private Byte dpDoneHdmp4;
    private Byte dpDoneMp4;
    private Double duration;
    private Integer files;
    private String letvAddr;
    private Integer letvVid;
    private String letvVu;
    private Integer mid;
    private Integer page;
    private Integer storage;
    private Integer storageServer;
    private String subtitle;
    private String title;
    private String type;
    private Integer upload;
    private Integer uploadMeta;
    private String vid;
    private Integer vp;
    private Integer typeId;

    @Id
    @Column(name = "cid")
    public int getCid() {
        return cid;
    }

    public void setCid(int cid) {
        this.cid = cid;
    }

    @Basic
    @Column(name = "aid")
    public Integer getAid() {
        return aid;
    }

    public void setAid(Integer aid) {
        this.aid = aid;
    }

    @Basic
    @Column(name = "author")
    public String getAuthor() {
        return author;
    }

    public void setAuthor(String author) {
        this.author = author;
    }

    @Basic
    @Column(name = "backup_vid")
    public String getBackupVid() {
        return backupVid;
    }

    public void setBackupVid(String backupVid) {
        this.backupVid = backupVid;
    }

    @Basic
    @Column(name = "cache")
    public String getCache() {
        return cache;
    }

    public void setCache(String cache) {
        this.cache = cache;
    }

    @Basic
    @Column(name = "cover")
    public String getCover() {
        return cover;
    }

    public void setCover(String cover) {
        this.cover = cover;
    }

    @Basic
    @Column(name = "dispatch")
    public Integer getDispatch() {
        return dispatch;
    }

    public void setDispatch(Integer dispatch) {
        this.dispatch = dispatch;
    }

    @Basic
    @Column(name = "dispatch_servers")
    public Integer getDispatchServers() {
        return dispatchServers;
    }

    public void setDispatchServers(Integer dispatchServers) {
        this.dispatchServers = dispatchServers;
    }

    @Basic
    @Column(name = "dp_done")
    public Byte getDpDone() {
        return dpDone;
    }

    public void setDpDone(Byte dpDone) {
        this.dpDone = dpDone;
    }

    @Basic
    @Column(name = "dp_done_flv")
    public Byte getDpDoneFlv() {
        return dpDoneFlv;
    }

    public void setDpDoneFlv(Byte dpDoneFlv) {
        this.dpDoneFlv = dpDoneFlv;
    }

    @Basic
    @Column(name = "dp_done_hdmp4")
    public Byte getDpDoneHdmp4() {
        return dpDoneHdmp4;
    }

    public void setDpDoneHdmp4(Byte dpDoneHdmp4) {
        this.dpDoneHdmp4 = dpDoneHdmp4;
    }

    @Basic
    @Column(name = "dp_done_mp4")
    public Byte getDpDoneMp4() {
        return dpDoneMp4;
    }

    public void setDpDoneMp4(Byte dpDoneMp4) {
        this.dpDoneMp4 = dpDoneMp4;
    }

    @Basic
    @Column(name = "duration")
    public Double getDuration() {
        return duration;
    }

    public void setDuration(Double duration) {
        this.duration = duration;
    }

    @Basic
    @Column(name = "files")
    public Integer getFiles() {
        return files;
    }

    public void setFiles(Integer files) {
        this.files = files;
    }

    @Basic
    @Column(name = "letv_addr")
    public String getLetvAddr() {
        return letvAddr;
    }

    public void setLetvAddr(String letvAddr) {
        this.letvAddr = letvAddr;
    }

    @Basic
    @Column(name = "letv_vid")
    public Integer getLetvVid() {
        return letvVid;
    }

    public void setLetvVid(Integer letvVid) {
        this.letvVid = letvVid;
    }

    @Basic
    @Column(name = "letv_vu")
    public String getLetvVu() {
        return letvVu;
    }

    public void setLetvVu(String letvVu) {
        this.letvVu = letvVu;
    }

    @Basic
    @Column(name = "mid")
    public Integer getMid() {
        return mid;
    }

    public void setMid(Integer mid) {
        this.mid = mid;
    }

    @Basic
    @Column(name = "page")
    public Integer getPage() {
        return page;
    }

    public void setPage(Integer page) {
        this.page = page;
    }

    @Basic
    @Column(name = "storage")
    public Integer getStorage() {
        return storage;
    }

    public void setStorage(Integer storage) {
        this.storage = storage;
    }

    @Basic
    @Column(name = "storage_server")
    public Integer getStorageServer() {
        return storageServer;
    }

    public void setStorageServer(Integer storageServer) {
        this.storageServer = storageServer;
    }

    @Basic
    @Column(name = "subtitle")
    public String getSubtitle() {
        return subtitle;
    }

    public void setSubtitle(String subtitle) {
        this.subtitle = subtitle;
    }

    @Basic
    @Column(name = "title")
    public String getTitle() {
        return title;
    }

    public void setTitle(String title) {
        this.title = title;
    }

    @Basic
    @Column(name = "type")
    public String getType() {
        return type;
    }

    public void setType(String type) {
        this.type = type;
    }

    @Basic
    @Column(name = "upload")
    public Integer getUpload() {
        return upload;
    }

    public void setUpload(Integer upload) {
        this.upload = upload;
    }

    @Basic
    @Column(name = "upload_meta")
    public Integer getUploadMeta() {
        return uploadMeta;
    }

    public void setUploadMeta(Integer uploadMeta) {
        this.uploadMeta = uploadMeta;
    }

    @Basic
    @Column(name = "vid")
    public String getVid() {
        return vid;
    }

    public void setVid(String vid) {
        this.vid = vid;
    }

    @Basic
    @Column(name = "vp")
    public Integer getVp() {
        return vp;
    }

    public void setVp(Integer vp) {
        this.vp = vp;
    }

    @Basic
    @Column(name = "type_id")
    public Integer getTypeId() {
        return typeId;
    }

    public void setTypeId(Integer typeId) {
        this.typeId = typeId;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        DataModel dataModel = (DataModel) o;
        return cid == dataModel.cid &&
                Objects.equals(aid, dataModel.aid) &&
                Objects.equals(author, dataModel.author) &&
                Objects.equals(backupVid, dataModel.backupVid) &&
                Objects.equals(cache, dataModel.cache) &&
                Objects.equals(cover, dataModel.cover) &&
                Objects.equals(dispatch, dataModel.dispatch) &&
                Objects.equals(dispatchServers, dataModel.dispatchServers) &&
                Objects.equals(dpDone, dataModel.dpDone) &&
                Objects.equals(dpDoneFlv, dataModel.dpDoneFlv) &&
                Objects.equals(dpDoneHdmp4, dataModel.dpDoneHdmp4) &&
                Objects.equals(dpDoneMp4, dataModel.dpDoneMp4) &&
                Objects.equals(duration, dataModel.duration) &&
                Objects.equals(files, dataModel.files) &&
                Objects.equals(letvAddr, dataModel.letvAddr) &&
                Objects.equals(letvVid, dataModel.letvVid) &&
                Objects.equals(letvVu, dataModel.letvVu) &&
                Objects.equals(mid, dataModel.mid) &&
                Objects.equals(page, dataModel.page) &&
                Objects.equals(storage, dataModel.storage) &&
                Objects.equals(storageServer, dataModel.storageServer) &&
                Objects.equals(subtitle, dataModel.subtitle) &&
                Objects.equals(title, dataModel.title) &&
                Objects.equals(type, dataModel.type) &&
                Objects.equals(upload, dataModel.upload) &&
                Objects.equals(uploadMeta, dataModel.uploadMeta) &&
                Objects.equals(vid, dataModel.vid) &&
                Objects.equals(vp, dataModel.vp) &&
                Objects.equals(typeId, dataModel.typeId);
    }

    @Override
    public int hashCode() {

        return Objects.hash(cid, aid, author, backupVid, cache, cover, dispatch, dispatchServers, dpDone, dpDoneFlv, dpDoneHdmp4, dpDoneMp4, duration, files, letvAddr, letvVid, letvVu, mid, page, storage, storageServer, subtitle, title, type, upload, uploadMeta, vid, vp, typeId);
    }

    @Override
    public Serializable primaryKey() {
        return getCid();
    }

    @Override
    public String tableNote() {
        return "history接口数据表";
    }
}
