package db.model.bilibili;

import db.AbstractModel;

import javax.persistence.*;
import java.io.Serializable;
import java.util.Objects;

@Entity
@Table(name = "task", schema = "bilibili", catalog = "bilibili")
public class TaskEntity extends AbstractModel {
    private int id;
    private String api;

    @Id
    @Column(name = "id")
    public int getId() {
        return id;
    }

    public void setId(int id) {
        this.id = id;
    }


    @Basic
    @Column(name = "api")
    public String getApi() {
        return api;
    }

    public void setApi(String api) {
        this.api = api;
    }


    @Override
    public Serializable primaryKey() {
        return getId();
    }

    @Override
    public String tableNote() {
        return "脚本任务";
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        TaskEntity that = (TaskEntity) o;
        return id == that.id &&
                Objects.equals(api, that.api);
    }

    @Override
    public int hashCode() {

        return Objects.hash(id, api);
    }
}
