package web.html;

import java.util.EnumSet;
import java.util.HashMap;
import java.util.Map;

public enum ElementId {
    menu("menu_"),
    button("btn_"),
    iframe("iframe_")
    ;

    private String id;

    ElementId(String id) {
        this.id = id;
    }

    public String getId() {
        return id;
    }

    public static Map<String,ElementId> getAll(){
        Map<String,ElementId> map=new HashMap<>();
        EnumSet.allOf(ElementId.class).forEach(elementId -> map.put(elementId.name(),elementId));
        return map;
    }
}
